package com.josyf.commandbuttons;

import com.josyf.commandbuttons.gui.ButtonGUI;
import com.josyf.commandbuttons.gui.ButtonGUIScreen;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.option.KeyBinding;
import net.minecraft.client.util.InputUtil;
import org.json.simple.JSONObject;
import org.lwjgl.glfw.GLFW;

import java.util.ArrayList;
import java.util.List;

public class CommandButtons implements ModInitializer {

    public static final String MOD_ID = "mgbuttons";
    private static ArrayList<JSONObject> masterCommList;

    @Override
    public void onInitialize() {
        assignGuiToKey();
        initArray();
    }

    private void assignGuiToKey() {
        // 默认G键触发GUI
        KeyBinding keyBinding = KeyBindingHelper.registerKeyBinding(new KeyBinding(
                "key.commandbuttons.opengui",
                InputUtil.Type.KEYSYM,
                GLFW.GLFW_KEY_G,
                "gui.commandbuttons.mgbuttons"
        ));

        ClientTickEvents.END_CLIENT_TICK.register(client -> {
            while (keyBinding.wasPressed()) {
                MinecraftClient.getInstance().setScreen(new ButtonGUIScreen(new ButtonGUI()));
            }
        });
    }


    // 执行命令，一行一行来
    public static void runCommands(List<String> commands) {
        MinecraftClient client = MinecraftClient.getInstance();
        if (client != null && client.player != null && client.player.networkHandler != null) {
            for (String command : commands) {
                if (command != null && !command.trim().isEmpty()) {
                    client.player.networkHandler.sendChatCommand(command.trim());
                }
            }
        }
    }

    static void initArray() {
        masterCommList = ConfigFile.getArrayFromJsonFile();
        // If commands.json doesn't exist yet, start a global list variable for future creation
        if (masterCommList == null) {
            setMasterCommList(new ArrayList<>());
        }
    }

    public static ArrayList<JSONObject> getMasterCommList() {
        return masterCommList;
    }

    public static void setMasterCommList(ArrayList<JSONObject> commList) {
        masterCommList = commList;
    }

    public static void refreshMasterCommList() {
        masterCommList = ConfigFile.getArrayFromJsonFile();
        if (masterCommList == null) {
            masterCommList = new ArrayList<>();
        }
    }
}
